%
% Optical Imaging and Spectroscopy
%
% David J. Brady
% Duke University
% www.opticalimaging.org
%
%  Figure 9.4
% Code written by Ashwin Wagadarikar and Nikos Pitisianis, Duke University
%
function [aligned shift maxshift] = alignSpectra(inverted,shift)
%function [aligned shift] = alignSpectra(inverted)
%
%This function aligns the spectral estimates from each mask column.

if nargin==1
    shift = findspecshift(inverted);
end

maxshift = max(shift);
[row col] = size(inverted);
padBlock = zeros(row,0);
inverted = [padBlock inverted padBlock];

for i = 1:row
    aligned(i,:) = circshift(inverted(i,:),[0 shift(i)]);
end