%
% Optical Imaging and Spectroscopy
%
% David J. Brady
% Duke University
% www.opticalimaging.org
%
%  Figure 9.4
% Code written by Ashwin Wagadarikar and Nikos Pitisianis, Duke University
%
function theshift=findspecshift(horcorrdata);
%function theshift=findspecshift(horcorrdata);
%
%shifts the spectra in each row using the middle row as the rotation point
%so that the spectrum in each row lines up with the spectrum in the next
%row.

[totalrows totalcols]=size(horcorrdata);

for i=1:totalrows
     theshift(i)=correlate(horcorrdata(i,:),horcorrdata(totalrows/2,:))-1;
end