%
% Optical Imaging and Spectroscopy
%
% David J. Brady
% Duke University
% www.opticalimaging.org
%
%  Figure 9.4
% Code written by Ashwin Wagadarikar and Nikos Pitisianis, Duke University
%
function wavelengths = getWavelengths(spectralchannel)
%function wavelengths = getWavelengths(spectralchannel)
%
%Given a spectral channel, this function returns the wavelength for the
%spectrometer at that spectral channel.

specchannelforfit = find_final_shift(spectralchannel,4);
wavelengthforfit = [916.265 904.545 895.225 881.941]; %nm

poly = polyfit(specchannelforfit,wavelengthforfit,3);       %Note, 3rd order fit done here.
wavelengths = polyval(poly,[1:length(spectralchannel)]);