%
% Optical Imaging and Spectroscopy
%
% David J. Brady
% Duke University
% www.opticalimaging.org
%
%  Figure 9.4
% Code written by Ashwin Wagadarikar and Nikos Pitisianis, Duke University
%
%
close all;clear all;clc;pack;
%Load the smile curvature polynomial
smilepoly = 'dec24smilefit.mat';
load(smilepoly);
%Load CCD image data
load ccddata;
subtract = double(myccd);


    figure(1);set(gcf,'color','white');colormap gray;
    subplot(3,2,1);imagesc((subtract));xlabel('Pixel');ylabel('Pixel');title('Raw CCD image'); 

CCDtrue = smileFix(subtract,polly);
subplot(3,2,2);imagesc((CCDtrue));xlabel('Pixel');ylabel('Pixel');title('Smile corrected CCD image'); 

%Load the encoding pattern
load encodingpattern;
encoding = flipud(encoder);
%subplot(3,2,3);imagesc((encoding));axis off;axis square;

%Run the reconstruction algorithm
tic
inverted = invert(fliplr(CCDtrue),encoding);
toc
subplot(3,2,3);imagesc(fliplr(inverted));title('Spectral estimates from each column of aperture code'); ylabel('Aperture column #'); xlabel('Pixel'); 

[rot shifts]= alignSpectra(inverted);

subplot(3,2,4);imagesc(fliplr(rot));title('Aligned spectral estimates');ylabel('Aperture column #');

spec = sum(rot(1:end,:));

    wavelengths = getWavelengths(spec);
    spec=spec/max(spec);
    subplot(3,1,3);plot(wavelengths,spec,'-k');title('Spectral estimate'); colormap gray;ylabel('Spectral density');xlabel('Wavelength (nm)');    
